#include "stdafx.h"
#include <iostream>
#include <algorithm>

using namespace std;

#include "CppUnitTest.h"
#include "BinaryTree.h"
using namespace cs242;

using namespace Microsoft::VisualStudio::CppUnitTestFramework;

namespace testSedgewickTree
{
	// This function will be used in the traverse test.
	void subtract1000(int& x)
	{
		x = x - 1000;
	}

	TEST_CLASS(redBlackTests)
	{
	public:

		// Insert into a tree using splayInsert
		TEST_METHOD(splayTest)
		{
			const int PAYLOAD = 10;
			BinaryTree<int>* root = 0;

			stringstream outputString;
			BinaryTree<int>::splayInsert(root, "a", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "s", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "e", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "r", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "c", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "h", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "i", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "n", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "g", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			string result = BinaryTree<int>::toString(root, ":");
			Assert::AreEqual(string("g:\ne:i:\nc:0:h:n:\na:0:0:0:0:r:\n0:0:0:s:\n"),
				result);
		}

		// A larger test for splay insertion
		TEST_METHOD(splayTestUL)
		{
			const int PAYLOAD = 10;
			BinaryTree<int>* root = 0;

			stringstream outputString;
			BinaryTree<int>::splayInsert(root, "u", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "n", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "i", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "v", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "e", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "r", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "s", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "t", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "y", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "o", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "f", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::splayInsert(root, "l", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			string result = BinaryTree<int>::toString(root, ":");
			Assert::AreEqual(string(
				"l:\nf:n:\ne:i:0:o:\n0:0:0:0:0:u:\ns:y:\nr:t:v:0:\n"),
				result);
		}


		// Add a boolean data member to the BinaryTree template class that
		// indicates whether a node is red or black.  If the third parameter
		// to the constructor is omitted, the node created should be black.
		TEST_METHOD(createRedNode)
		{
			bool isRed = true;
			int PAYLOAD = 10;
			BinaryTree<int>* root = new BinaryTree<int>(string("a"), PAYLOAD, isRed);
			Assert::IsTrue(BinaryTree<int>::isRed(root));
		}

		TEST_METHOD(createBlackNode)
		{
			bool isRed = true;
			int PAYLOAD = 10;
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "a", PAYLOAD);
			Assert::IsFalse(BinaryTree<int>::isRed(root));
		}


		// When we output a node's name, we want it capitalized if the node is red.
		// Write the member function:
		// string BinaryTree<Type>::printName(BinaryTree<Type>* root) to return
		// a capitalized string when the node is red.
		TEST_METHOD(redNodeToString)
		{
			bool isRed = true;
			int PAYLOAD = 10;
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "apple", PAYLOAD);
			Assert::AreEqual(string("Apple:\n"), BinaryTree<int>::toString(root,":"));
		}

		TEST_METHOD(blackNodeToString)
		{
			bool isRed = false;
			int PAYLOAD = 10;

			// Explicitly create a black node.
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "apple", PAYLOAD);
			Assert::AreEqual(string("apple:\n"), BinaryTree<int>::toString(root,":"));
		}

		// Modify the BinaryTree<Type>::print function to use the printName function.
		TEST_METHOD(printRedBlackTree)
		{
			bool isRed = false;
			int PAYLOAD = 10;

			stringstream outputString;
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "apple", PAYLOAD);
			BinaryTree<int>::redBlackInsert(root, "Orange", PAYLOAD);

			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			string outString = outputString.str();
			Assert::AreEqual(string("     apple\n   Orange     \n"), outputString.str());
		}


		// Red-black insertion!
		TEST_METHOD(redBlackULTest)
		{
			const int PAYLOAD = 10;
			BinaryTree<int>* root = 0;

			stringstream outputString;
			BinaryTree<int>::redBlackInsert(root, "u", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "n", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "i", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "v", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "e", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "r", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "s", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "t", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "y", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "o", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "f", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "l", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "c", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "h", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "b", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			BinaryTree<int>::redBlackInsert(root, "g", PAYLOAD);
			BinaryTree<int>::print(outputString, root, 2);
			Logger::WriteMessage(outputString.str().c_str());
			outputString.str(string());
			outputString.clear();

			string result = BinaryTree<int>::toString(root, ":");
			Assert::AreEqual(string("s:\ni:u:\nF:N:t:v:\nc:h:l:r:0:0:0:Y:\nB:E:G:0:0:0:O:0:0:0:\n"),
				result);
		}

		// Normal BST lookup should work with red-black trees.
		TEST_METHOD(lookupTest)
		{
			const int PAYLOAD = 10;
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "Carlsen", 2827);
			BinaryTree<int>::redBlackInsert(root, "Maxime", 2804);
			BinaryTree<int>::redBlackInsert(root, "Kramnik", 2803);
			BinaryTree<int>::redBlackInsert(root, "Aronian", 2802);
			BinaryTree<int>::redBlackInsert(root, "Caruana", 2799);
			BinaryTree<int>::redBlackInsert(root, "Mamedyarov", 2797);
			BinaryTree<int>::redBlackInsert(root, "Anand", 2794);
			BinaryTree<int>::redBlackInsert(root, "So", 2792);
			BinaryTree<int>::redBlackInsert(root, "Grischuk", 2788);
			BinaryTree<int>::redBlackInsert(root, "Nakamura", 2781);

			int rating;
			bool found;

			found = BinaryTree<int>::lookup(root, string("Carlsen"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2827, rating);

			found = BinaryTree<int>::lookup(root, string("Maxime"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2804, rating);

			found = BinaryTree<int>::lookup(root, string("Kramnik"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2803, rating);

			found = BinaryTree<int>::lookup(root, string("Aronian"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2802, rating);

			found = BinaryTree<int>::lookup(root, string("Caruana"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2799, rating);

			found = BinaryTree<int>::lookup(root, string("Mamedyarov"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2797, rating);

			found = BinaryTree<int>::lookup(root, string("Anand"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2794, rating);

			found = BinaryTree<int>::lookup(root, string("So"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2792, rating);

			found = BinaryTree<int>::lookup(root, string("Grischuk"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2788, rating);

			found = BinaryTree<int>::lookup(root, string("Nakamura"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(2781, rating);

			found = BinaryTree<int>::lookup(root, string("Ribler"), rating);
			Assert::IsFalse(found);
		}


		// Delete a tree, recovering all the memory.
		TEST_METHOD(deleteTest)
		{
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "Carlsen", 2827);
			BinaryTree<int>::redBlackInsert(root, "Maxime", 2804);
			BinaryTree<int>::redBlackInsert(root, "Kramnik", 2803);
			BinaryTree<int>::redBlackInsert(root, "Aronian", 2802);
			BinaryTree<int>::redBlackInsert(root, "Caruana", 2799);
			BinaryTree<int>::redBlackInsert(root, "Mamedyarov", 2797);
			BinaryTree<int>::redBlackInsert(root, "Anand", 2794);
			BinaryTree<int>::redBlackInsert(root, "So", 2792);
			BinaryTree<int>::redBlackInsert(root, "Grischuk", 2788);
			BinaryTree<int>::redBlackInsert(root, "Nakamura", 2781);
			BinaryTree<int>::postOrderTraverse(root, subtract1000);
			BinaryTree<int>::DeleteTree(root);
		}

		// Execute a function on the payload of every node.
		TEST_METHOD(traverseTest)
		{
			BinaryTree<int>* root = 0;
			BinaryTree<int>::redBlackInsert(root, "Carlsen", 2827);
			BinaryTree<int>::redBlackInsert(root, "Maxime", 2804);
			BinaryTree<int>::redBlackInsert(root, "Kramnik", 2803);
			BinaryTree<int>::redBlackInsert(root, "Aronian", 2802);
			BinaryTree<int>::redBlackInsert(root, "Caruana", 2799);
			BinaryTree<int>::redBlackInsert(root, "Mamedyarov", 2797);
			BinaryTree<int>::redBlackInsert(root, "Anand", 2794);
			BinaryTree<int>::redBlackInsert(root, "So", 2792);
			BinaryTree<int>::redBlackInsert(root, "Grischuk", 2788);
			BinaryTree<int>::redBlackInsert(root, "Nakamura", 2781);

			BinaryTree<int>::postOrderTraverse(root, subtract1000);
			int rating;
			bool found;

			found = BinaryTree<int>::lookup(root, string("Carlsen"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1827, rating);

			found = BinaryTree<int>::lookup(root, string("Maxime"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1804, rating);

			found = BinaryTree<int>::lookup(root, string("Kramnik"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1803, rating);

			found = BinaryTree<int>::lookup(root, string("Aronian"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1802, rating);

			found = BinaryTree<int>::lookup(root, string("Caruana"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1799, rating);

			found = BinaryTree<int>::lookup(root, string("Mamedyarov"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1797, rating);

			found = BinaryTree<int>::lookup(root, string("Anand"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1794, rating);

			found = BinaryTree<int>::lookup(root, string("So"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1792, rating);

			found = BinaryTree<int>::lookup(root, string("Grischuk"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1788, rating);

			found = BinaryTree<int>::lookup(root, string("Nakamura"), rating);
			Assert::IsTrue(found);
			Assert::AreEqual(1781, rating);

			found = BinaryTree<int>::lookup(root, string("Ribler"), rating);
			Assert::IsFalse(found);

			BinaryTree<int>::DeleteTree(root);
		}
	};
}
